<div class="wrap">
	<h2><?php echo esc_html($GLOBALS['title']); ?></h2>

	<form method="post" action="<?php echo esc_attr(admin_url('admin-post.php')); ?>">
		<table class="widefat">
			<tbody>
				<tr>
					<th scope="row"><label for="sjdr_time"><?php _e('Defer publishing by', 'sjdrss'); ?></label></th>
					<td><input type="text" id="sjdr_time" name="options[time]" value="<?php echo esc_attr($options['time']); ?>"/></td>
					<td><?php _e('Set to 0 for immediate publishing.', 'sjdrss'); ?></td>
				</tr>
				<tr>
					<th scope="row"><?php _e('Time units', 'sjdrss'); ?></th>
					<td>
						<label><input type="radio" name="options[units]" value="MINUTE"<?php checked('MINUTE', $options['units']); ?>/> <?php _e('Minutes', 'sjdrss'); ?></label><br/>
						<label><input type="radio" name="options[units]" value="HOUR"<?php checked('HOUR', $options['units']); ?>/> <?php _e('Hours', 'sjdrss'); ?></label><br/>
						<label><input type="radio" name="options[units]" value="DAY"<?php checked('DAY', $options['units']); ?>/> <?php _e('Days', 'sjdrss'); ?></label><br/>
					</td>
					<td>&nbsp;</td>
				</tr>
				<tr>
					<th scope="row"><label for="sjdr_copyrights"><?php _e('Add copyright notice to the feed', 'sjdrss'); ?></label></th>
					<td><textarea id="sjdr_copyrights" name="options[copyrights]" rows="5" cols="30" style="width: 100%"><?php echo esc_html($options['copyrights']); ?></textarea></td>
					<td>
						<strong><?php _e('Placeholders:', 'sjdrss'); ?></strong>
						<ul>
							<li><code>%1$d</code>: <?php echo sprintf(__('Year (e.g.: %d)', 'sjdrss'), date('Y')); ?></li>
							<li><code>%2$s</code>: <?php echo sprintf(__('Blog URL (e.g.: %s)', 'sjdrss'), esc_html(get_option('home'))); ?></li>
							<li><code>%3$s</code>: <?php echo sprintf(__('Blog Name (e.g.: %s)', 'sjdrss'), esc_html(get_option('blogname'))); ?></li>
							<li><code>%4$s</code>: <?php _e('Permalink', 'sjdrss'); ?></li>
						</ul>
						<?php _e("HTML is allowed.", 'sjdrss'); ?><br/>
						<?php _e("Leave blank to disable.", 'sjdrss'); ?>
					</td>
				</tr>
				<tr>
					<th scope="row"><?php _e('Replace Russian letters with English ones', 'sjdrss'); ?></th>
					<td>
						<label><input type="radio" name="options[rus_replace]" value="0"<?php checked($options['rus_replace'], 0); ?>/> <?php _e('No', 'sjdrss'); ?></label><br/>
						<label><input type="radio" name="options[rus_replace]" value="1"<?php checked($options['rus_replace'], 1); ?>/> <?php _e('Yes', 'sjdrss'); ?></label><br/>
					</td>
					<td>&nbsp;</td>
				</tr>
			</tbody>
		</table>

		<p class="submit">
			<?php wp_nonce_field('save-sjdrss_settings'); ?>
			<input type="hidden" name="action" value="sjdrss_save_settings"/>
			<input type="submit" value="<?php _e('Save Changes', 'sjdrss') ?>" class="button button-primary"/>
		</p>
	</form>
</div>
